---
title: HashChangeEvent
slug: Web/API/HashChangeEvent
tags:
  - API
  - Event
  - HTML5
  - HashChange
  - Interface
  - Reference
  - events
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <code><strong>HashChangeEvent</strong></code> interface represents events that fire when the fragment identifier of the URL has changed.</p>

<p>The fragment identifier is the part of the URL that follows (and includes) the <code>#</code> symbol.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits the properties of its parent, {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("HashChangeEvent.newURL")}} {{readonlyInline}} {{gecko_minversion_inline("6.0")}}</dt>
 <dd>The new URL to which the window is navigating.</dd>
 <dt>{{domxref("HashChangeEvent.oldURL")}} {{readonlyInline}} {{gecko_minversion_inline("6.0")}}</dt>
 <dd>The previous URL from which the window was navigated.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface has no methods of its own, but inherits the methods of its parent, {{domxref("Event")}}.</em></p>

<h2 id="Examples">Examples</h2>

<h3 id="Syntax_options_for_a_hash_change">Syntax options for a hash change</h3>

<p>You can listen for the {{event("hashchange")}} event using any of the following options:</p>

<pre class="brush: js notranslate">window.onhashchange = funcRef;
</pre>

<p><strong>or</strong></p>

<pre class="brush: html notranslate">&lt;body onhashchange="funcRef();"&gt;
</pre>

<p><strong>or</strong></p>

<pre class="brush: js notranslate">window.addEventListener("hashchange", funcRef, false);
</pre>

<h3 id="Basic_example">Basic example</h3>

<pre class="brush:js notranslate">function locationHashChanged() {
  if (location.hash === '#somecoolfeature') {
    somecoolfeature();
  }
}

window.addEventListener('hashchange', locationHashChanged);
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>There are several fallback scripts listed on the <a href="https://github.com/Modernizr/Modernizr/wiki/HTML5-Cross-Browser-Polyfills">Modernizr GitHub page</a>. Basically, those scripts check the {{domxref("HTMLHyperlinkElementUtils.hash", "location.hash")}} at a regular interval. Here is a version that allows only one handler to be bound to the {{domxref("WindowEventHandlers.onhashchange", "onhashchange")}} property:</p>

<pre class="brush:js; notranslate">;(function(window) {

  // Exit if the browser implements that event
  if ( "onhashchange" in window.document.body ) { return; }

  var location = window.location,
      oldURL = location.href,
      oldHash = location.hash;

  // Check the location hash on a 100ms interval
  setInterval(function() {
    var newURL = location.href,
        newHash = location.hash;

    // If the hash has changed and a handler has been bound...
    if ( newHash != oldHash &amp;&amp; typeof window.onhashchange === "function" ) {
      // Execute the handler
      window.onhashchange({
        type: "hashchange",
        oldURL: oldURL,
        newURL: newURL
      });

      oldURL = newURL;
      oldHash = newHash;
    }
  }, 100);

})(window);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#the-hashchangeevent-interface", "HashChangeEvent")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HashChangeEvent")}}</p>

<h2 id="Related_events">Related events</h2>

<ul>
 <li>{{event("hashchange")}}</li>
 <li>{{event("popstate")}}</li>
</ul>
